

; For TA = (-> (& (-> (& a f) o) f) o):
;
; (show-stream (find-monad bt))
;
; {((lambda (x0)
;     (lambda (x1) ((left x1) (pair x0 (right x1)))))
;
;   (lambda (x0)
;     (lambda (x1)
;       (x0 (pair (lambda (x4)
;                   ((left x4) (pair (lambda (x5)
;                                      ((left x1) (pair (left x5) (right x5))))
;                                    (right x4))))
;                 (right x1)))))
;
;   (lambda (x0)
;     (lambda (x1)
;       (lambda (x2)
;         (x1 (pair (lambda (x5) ((left x2) (pair (x0 (left x5)) (right x5))))
;                   (right x2)))))))}


(define (find-monad T)
  (show-stream
   (filter-stream (lambda (candidate)
		    (let ((eta (lambda (x)
				 `(,(car candidate) ,x)))
			  (mu (lambda (x)
				`(,(cadr candidate) ,x)))
			  (map (lambda (f)
				 (lambda (x)
				   `((,(caddr candidate) (lambda (z) ,(f 'z)))
				     ,x))))
			  (x 'x)
			  (= (lambda (x y)
			       (equal? (normal x) (normal y)))))

		      (and (= (mu (mu x)) (mu ((map mu) x)))
			   (= (mu (eta x)) x)
			   (= x (mu ((map eta) x))))))

		  (product-stream list
				  (pr (-> p (T p)))
				  (pr (-> (T (T p)) (T p)))
				  (pr (-> (-> p q) (-> (T p) (T q))))))))



; Loses on exceptions monad because of the normalizer's failure to deal
; with sums properly.  It really needs to CPS convert or something...
;
;   (f (sum-case x f1 f2))  =>  (sum-case x (o f f1) (o f f2))
