
(define unit '())			; () : 1

(define pair cons)
(define left car)
(define right cdr)

(define (in-left x)			; iota_1 : A -> A + B
  (if (eq? x unit) #t (vector 'in-left x)))
(define (in-right y)			; iota_2 : B -> A + B
  (if (eq? y unit) #f (vector 'in-right y)))

(define (sum-case a/b f g)
  (cond ((eq? a/b #t) (f unit))
	((eq? a/b #f) (g unit))
	((and (vector? a/b) (eq? (vector-ref a/b 0) 'in-left))
	 (f (vector-ref a/b 1)))
	((and (vector? a/b) (eq? (vector-ref a/b 0) 'in-right))
	 (g (vector-ref a/b 1)))
	(else (error "bogus argument to sum-case" a/b))))
